Package com.arms.egovframework.javaservice.treeframework.controller

## Class TreeAbstractController<T extends TreeService,​D extends TreeBaseDTO,​V extends TreeSearchEntity>

- java.lang.Object
- - com.arms.egovframework.javaservice.treeframework.controller.TreeAbstractController<T,​D,​V>

- Direct Known Subclasses:
    `AdminPatchController`, `BlogController`, `ClientCaseController`, `DynamicDBMakerController`, `FileRepositoryController`, `FileRepositoryLogController`, `HolidayController`, `JiraIssuePriorityController`, `JiraIssuePriorityLogController`, `JiraIssueResolutionController`, `JiraIssueResolutionLogController`, `JiraIssueStatusCategoryMapController`, `JiraIssueStatusController`, `JiraIssueStatusLogController`, `JiraIssueTypeController`, `JiraIssueTypeLogController`, `JiraProjectController`, `JiraProjectIssueTypePureController`, `JiraProjectLogController`, `JiraProjectPureController`, `JiraServerController`, `JiraServerLogController`, `JiraServerProjectPureController`, `JiraServerPureController`, `NewsletterController`, `PatchnoteController`, `PdServiceController`, `PdServiceDetailController`, `PdServiceLogController`, `PdServicePureController`, `PdServiceVersionController`, `PdServiceVersionLogController`, `ReceiverController`, `ReceiverLogController`, `ReqAddController`, `ReqAddLogController`, `ReqAddPureController`, `ReqAddStatePureController`, `ReqCommentController`, `ReqCommentLogController`, `ReqDifficultyController`, `ReqPriorityController`, `ReqReviewCommentController`, `ReqReviewCommentLogController`, `ReqReviewController`, `ReqReviewLogController`, `ReqStateCategoryController`, `ReqStateCategoryLogController`, `ReqStateController`, `ReqStatusController`, `ReqStatusLogController`, `SalaryController`, `SalaryLogController`, `SenderController`, `SenderLogController`, `WikiController`

      public abstract class TreeAbstractController<T extends TreeService,​D extends TreeBaseDTO,​V extends TreeSearchEntity>
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected Chat` | `chat` |
    `protected org.modelmapper.ModelMapper` | `modelMapper` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TreeAbstractController()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `org.springframework.web.servlet.ModelAndView` | `addNode​(D treeBaseDTO, org.springframework.validation.BindingResult bindingResult, org.springframework.ui.ModelMap model)` |
    `org.springframework.web.servlet.ModelAndView` | `alterNode​(D treeBaseDTO, org.springframework.validation.BindingResult bindingResult, org.springframework.ui.ModelMap model)` |
    `org.springframework.web.servlet.ModelAndView` | `alterNodeType​(D treeBaseDTO, org.springframework.validation.BindingResult bindingResult, org.springframework.ui.ModelMap model)` |
    `org.springframework.web.servlet.ModelAndView` | `analyzeNode​(org.springframework.ui.ModelMap model)` |
    `org.springframework.web.servlet.ModelAndView` | `getChildNode​(D treeBaseDTO, javax.servlet.http.HttpServletRequest request)` |
    `org.springframework.web.servlet.ModelAndView` | `getMonitor​(D treeBaseDTO, org.springframework.ui.ModelMap model, javax.servlet.http.HttpServletRequest request)` |
    `org.springframework.web.servlet.ModelAndView` | `getNode​(D treeBaseDTO, javax.servlet.http.HttpServletRequest request)` |
    `org.springframework.web.servlet.ModelAndView` | `getNodesWithoutRoot​(D treeBaseDTO)` |
    `org.springframework.web.servlet.ModelAndView` | `getPaginatedChildNode​(D treeBaseDTO, org.springframework.ui.ModelMap model, javax.servlet.http.HttpServletRequest request)` |
    `org.springframework.web.servlet.ModelAndView` | `moveNode​(D treeBaseDTO, org.springframework.validation.BindingResult bindingResult, org.springframework.ui.ModelMap model, javax.servlet.http.HttpServletRequest request)` |
    `org.springframework.web.servlet.ModelAndView` | `removeNode​(D treeBaseDTO, org.springframework.validation.BindingResult bindingResult, org.springframework.ui.ModelMap model)` |
    `org.springframework.web.servlet.ModelAndView` | `searchNode​(D treeBaseDTO, org.springframework.ui.ModelMap model, javax.servlet.http.HttpServletRequest request)` |
    `org.springframework.http.ResponseEntity<?>` | `sendMessage​(java.lang.String message)` |
    `void` | `setJsonDefaultSetting​(V treeSearchEntity)` |
    `void` | `setTreeEntity​(java.lang.Class<V> treeEntity)` |
    `void` | `setTreeService​(T treeService)` |
    `org.springframework.web.servlet.ModelAndView` | `updateNode​(D treeBaseDTO, org.springframework.validation.BindingResult bindingResult, javax.servlet.http.HttpServletRequest request, org.springframework.ui.ModelMap model)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### modelMapper

          @Autowired
          protected org.modelmapper.ModelMapper modelMapper

    - #### chat

          @Autowired
          protected Chat chat

  - ### Constructor Detail

    - #### TreeAbstractController

          public TreeAbstractController()

  - ### Method Detail

    - #### setTreeService

          public void setTreeService​(T treeService)

    - #### setTreeEntity

          public void setTreeEntity​(java.lang.Class<V> treeEntity)

    - #### getNode

          @ResponseBody
          @RequestMapping(value="/getNode.do",
                          method=GET)
          public org.springframework.web.servlet.ModelAndView getNode​(D treeBaseDTO,
                                                                      javax.servlet.http.HttpServletRequest request)
                                                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getChildNode

          @ResponseBody
          @RequestMapping(value="/getChildNode.do",
                          method=GET)
          public org.springframework.web.servlet.ModelAndView getChildNode​(D treeBaseDTO,
                                                                           javax.servlet.http.HttpServletRequest request)
                                                                    throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getNodesWithoutRoot

          @ResponseBody
          @RequestMapping(value="/getNodesWithoutRoot.do",
                          method=GET)
          public org.springframework.web.servlet.ModelAndView getNodesWithoutRoot​(D treeBaseDTO)
                                                                           throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getPaginatedChildNode

          @ResponseBody
          @RequestMapping(value="/getPaginatedChildNode.do",
                          method=GET)
          public org.springframework.web.servlet.ModelAndView getPaginatedChildNode​(D treeBaseDTO,
                                                                                    org.springframework.ui.ModelMap model,
                                                                                    javax.servlet.http.HttpServletRequest request)
                                                                             throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### searchNode

          @ResponseBody
          @RequestMapping(value="/searchNode.do",
                          method=GET)
          public org.springframework.web.servlet.ModelAndView searchNode​(D treeBaseDTO,
                                                                         org.springframework.ui.ModelMap model,
                                                                         javax.servlet.http.HttpServletRequest request)
                                                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### addNode

          @ResponseBody
          @RequestMapping(value="/addNode.do",
                          method=POST)
          public org.springframework.web.servlet.ModelAndView addNode​(@Validated(AddNode.class)
                                                                      D treeBaseDTO,
                                                                      org.springframework.validation.BindingResult bindingResult,
                                                                      org.springframework.ui.ModelMap model)
                                                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### removeNode

          @ResponseBody
          @RequestMapping(value="/removeNode.do",
                          method=DELETE)
          public org.springframework.web.servlet.ModelAndView removeNode​(@Validated(RemoveNode.class)
                                                                         D treeBaseDTO,
                                                                         org.springframework.validation.BindingResult bindingResult,
                                                                         org.springframework.ui.ModelMap model)
                                                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### setJsonDefaultSetting

          public void setJsonDefaultSetting​(V treeSearchEntity)

    - #### updateNode

          @ResponseBody
          @RequestMapping(value="/updateNode.do",
                          method=PUT)
          public org.springframework.web.servlet.ModelAndView updateNode​(@Validated(UpdateNode.class)
                                                                         D treeBaseDTO,
                                                                         org.springframework.validation.BindingResult bindingResult,
                                                                         javax.servlet.http.HttpServletRequest request,
                                                                         org.springframework.ui.ModelMap model)
                                                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### alterNode

          @ResponseBody
          @RequestMapping(value="/alterNode.do",
                          method=PUT)
          public org.springframework.web.servlet.ModelAndView alterNode​(@Validated(AlterNode.class)
                                                                        D treeBaseDTO,
                                                                        org.springframework.validation.BindingResult bindingResult,
                                                                        org.springframework.ui.ModelMap model)
                                                                 throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### alterNodeType

          @ResponseBody
          @RequestMapping(value="/alterNodeType.do",
                          method=PUT)
          public org.springframework.web.servlet.ModelAndView alterNodeType​(@Validated(AlterNodeType.class)
                                                                            D treeBaseDTO,
                                                                            org.springframework.validation.BindingResult bindingResult,
                                                                            org.springframework.ui.ModelMap model)
                                                                     throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### moveNode

          @ResponseBody
          @RequestMapping(value="/moveNode.do",
                          method=POST)
          public org.springframework.web.servlet.ModelAndView moveNode​(@Validated(MoveNode.class)
                                                                       D treeBaseDTO,
                                                                       org.springframework.validation.BindingResult bindingResult,
                                                                       org.springframework.ui.ModelMap model,
                                                                       javax.servlet.http.HttpServletRequest request)
                                                                throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### analyzeNode

          @ResponseBody
          @RequestMapping(value="/analyzeNode.do",
                          method=GET)
          public org.springframework.web.servlet.ModelAndView analyzeNode​(org.springframework.ui.ModelMap model)

    - #### getMonitor

          @ResponseBody
          @RequestMapping(value="/getMonitor.do",
                          method=GET)
          public org.springframework.web.servlet.ModelAndView getMonitor​(D treeBaseDTO,
                                                                         org.springframework.ui.ModelMap model,
                                                                         javax.servlet.http.HttpServletRequest request)
                                                                  throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### sendMessage

          @ResponseBody
          @GetMapping("/send-message")
          public org.springframework.http.ResponseEntity<?> sendMessage​(@RequestParam("message")
                                                                        java.lang.String message)